/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreMissingvalue.TCoreMissingvaluePath;
import de.ship.db.tables.TDmMissingvalue.TDmMissingvaluePath;
import de.ship.db.tables.records.TDmMissingcodeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmMissingcode extends TableImpl<TDmMissingcodeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_missingcode</code>
     */
    public static final TDmMissingcode T_DM_MISSINGCODE = new TDmMissingcode();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmMissingcodeRecord> getRecordType() {
        return TDmMissingcodeRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_missingcode.lastchange</code>.
     */
    public final TableField<TDmMissingcodeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_missingcode.pk</code>.
     */
    public final TableField<TDmMissingcodeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_missingcode.num_missingcode</code>.
     * numerical missing code
     */
    public final TableField<TDmMissingcodeRecord, Integer> NUM_MISSINGCODE = createField(DSL.name("num_missingcode"), SQLDataType.INTEGER.nullable(false), this, "numerical missing code");

    /**
     * The column <code>common_dd.t_dm_missingcode.sas_missingcode</code>. sas
     * missing code (e.g. .J for jump or whatever)
     */
    public final TableField<TDmMissingcodeRecord, String> SAS_MISSINGCODE = createField(DSL.name("sas_missingcode"), SQLDataType.CLOB.nullable(false), this, "sas missing code (e.g. .J for jump or whatever)");

    /**
     * The column <code>common_dd.t_dm_missingcode.date_missingcode</code>. date
     * missing code
     */
    public final TableField<TDmMissingcodeRecord, LocalDateTime> DATE_MISSINGCODE = createField(DSL.name("date_missingcode"), SQLDataType.LOCALDATETIME(6).nullable(false), this, "date missing code");

    private TDmMissingcode(Name alias, Table<TDmMissingcodeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmMissingcode(Name alias, Table<TDmMissingcodeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_missingcode</code> table reference
     */
    public TDmMissingcode(String alias) {
        this(DSL.name(alias), T_DM_MISSINGCODE);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_missingcode</code> table reference
     */
    public TDmMissingcode(Name alias) {
        this(alias, T_DM_MISSINGCODE);
    }

    /**
     * Create a <code>common_dd.t_dm_missingcode</code> table reference
     */
    public TDmMissingcode() {
        this(DSL.name("t_dm_missingcode"), null);
    }

    public <O extends Record> TDmMissingcode(Table<O> path, ForeignKey<O, TDmMissingcodeRecord> childPath, InverseForeignKey<O, TDmMissingcodeRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_MISSINGCODE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmMissingcodePath extends TDmMissingcode implements Path<TDmMissingcodeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmMissingcodePath(Table<O> path, ForeignKey<O, TDmMissingcodeRecord> childPath, InverseForeignKey<O, TDmMissingcodeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmMissingcodePath(Name alias, Table<TDmMissingcodeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmMissingcodePath as(String alias) {
            return new TDmMissingcodePath(DSL.name(alias), this);
        }

        @Override
        public TDmMissingcodePath as(Name alias) {
            return new TDmMissingcodePath(alias, this);
        }

        @Override
        public TDmMissingcodePath as(Table<?> alias) {
            return new TDmMissingcodePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmMissingcodeRecord, Integer> getIdentity() {
        return (Identity<TDmMissingcodeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmMissingcodeRecord> getPrimaryKey() {
        return Keys.PK_DM_MISSINGCODE;
    }

    @Override
    public List<UniqueKey<TDmMissingcodeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_MISSINGCODE);
    }

    private transient TDmMissingvaluePath _tDmMissingvalue;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_missingvalue</code> table
     */
    public TDmMissingvaluePath tDmMissingvalue() {
        if (_tDmMissingvalue == null)
            _tDmMissingvalue = new TDmMissingvaluePath(this, null, Keys.T_DM_MISSINGVALUE__FK_DM_MV_MC.getInverseKey());

        return _tDmMissingvalue;
    }

    /**
     * Get the implicit many-to-many join path to the
     * <code>common_dd.t_core_missingvalue</code> table
     */
    public TCoreMissingvaluePath tCoreMissingvalue() {
        return tDmMissingvalue().tCoreMissingvalue();
    }

    @Override
    public TDmMissingcode as(String alias) {
        return new TDmMissingcode(DSL.name(alias), this);
    }

    @Override
    public TDmMissingcode as(Name alias) {
        return new TDmMissingcode(alias, this);
    }

    @Override
    public TDmMissingcode as(Table<?> alias) {
        return new TDmMissingcode(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingcode rename(String name) {
        return new TDmMissingcode(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingcode rename(Name name) {
        return new TDmMissingcode(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmMissingcode rename(Table<?> name) {
        return new TDmMissingcode(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode where(Condition condition) {
        return new TDmMissingcode(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingcode where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingcode where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingcode where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmMissingcode where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmMissingcode whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
